找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 580|回复: 0

[VBA程序]:获得封闭多义线的型心

[复制链接]

已领礼包: 145个

财富等级: 日进斗金

发表于 2002-9-27 17:50:05 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
Getting the centroid of a closed polyline  
ID    35353  
Applies to:    AutoCAD Map
AutoCAD Map
AutoCAD Map 2000

This document is part of    Polyline   Regions   VBA   AutoCAD MAP Technical Newsletter - January 2000   Map Automation     


  1. [FONT=courier new]
  2. Question
  3. How do I get the centroid of a closed polyline in AutoCAD Map 5 without
  4. creating a topology?
  5. Answer
  6. You need to form a Region object from the polyline and then calculate the
  7. centroid of the region. The Visual Basic code example that follows shows how
  8. this is done.


  9. Sub GetCentroid()

  10. Dim Doc As AcadDocument
  11. Dim Entity As AcadEntity
  12. Dim Region As AcadRegion
  13. Dim Polylist(0 To 0) As AcadEntity
  14. Dim Entities As AcadModelSpace
  15. Dim nPoly As Integer  'number of polylines
  16. Dim i As Integer
  17. Set Doc = ThisDrawing
  18. Set Entities = Doc.ModelSpace
  19. Dim Centroid As Variant



  20. 'Form a region from each polyline
  21. For Each Entity In Entities

  22. If Entity.ObjectName = "AcDbPolyline" Then  'Polyline ?
  23.     Set Polylist(0) = Entity
  24.     Entities.AddRegion Polylist
  25.    MsgBox Entity.ObjectName
  26. End If
  27.   
  28. Next

  29. 'Find centroid of each region
  30. For i = 0 To Entities.Count - 1

  31. If Entities.Item(i).ObjectName = "AcDbRegion" Then  'Region ?
  32.     Set Region = Entities.Item(i)
  33.     Centroid = Region.Centroid
  34.     MsgBox "Centroid X: " & Centroid(0) & vbCrLf & "Centroid Y: " & Centroid(1)
  35. End If
  36.   
  37. Next


  38. End Sub
  39. [/FONT]
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-5-6 13:04 , Processed in 0.359416 second(s), 31 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表